#if !defined(___Class_LTT1)
    #define  ___Class_LTT1

#include <iostream>
#include <deque>
////#include <TObject.h>
#include "ReconResonance/RmatrixLimited/endf/Nodes.h"
#include "ReconResonance/RmatrixLimited/endf/LIST.h"
#include "ReconResonance/RmatrixLimited/endf/TAB1.h"
#include "ReconResonance/RmatrixLimited/endf/LTT2.h"
#include "ReconResonance/RmatrixLimited/endf/Interp1.h"

class LTT1 : public virtual TAB2 {

 public:

  class Record : public LIST {

   public:

    Record();
    Record( const LIST& o );

    virtual ~Record();

    double  T () const { return this->C1 (); }
    double& T ()       { return this->C1 (); }
    double  E () const { return this->C2 (); }
    double& E ()       { return this->C2 (); }
    int     LT() const { return this->L1 (); }
    int&    LT()       { return this->L1 (); }
    int     NL() const { return this->NPL(); }
    int&    NL()       { return this->NPL(); }

    Record* T ( const double val ) { this->C1 (val);  return this; }
    Record* E ( const double val ) { this->C2 (val);  return this; }
    Record* LT( const int    val ) { this->L1 (val);  return this; }
    Record* NL( const int    val ) { this->NPL(val);  return this; }

    double  a( const int l ) const;

    ////ClassDef( LTT1::Record, 1 );

  };

 private:

  deque<LTT1::Record> array;

 public:

  LTT1();
  LTT1( const int n, const int interpcode = 2 );

  virtual ~LTT1();

  Record  at( const int i ) const;
  Record& at( const int i );

  Record  operator[]( const int i ) const;
  Record& operator[]( const int i );

  int  size () const;
  bool empty() const;

  Record  Front() const;
  Record& Front();
  Record  Back () const;
  Record& Back ();

  int  NE() const { return this->TAB2::NZ(); }
  int& NE()       { return this->TAB2::NZ(); }

  double  T ( const int i ) const { return this->at(i).T (); }
  double& T ( const int i )       { return this->at(i).T (); }
  double  E ( const int i ) const { return this->at(i).E (); }
  double& E ( const int i )       { return this->at(i).E (); }
  int     LT( const int i ) const { return this->at(i).LT(); }
  int&    LT( const int i )       { return this->at(i).LT(); }
  int     NL( const int i ) const { return this->at(i).NL(); }
  int&    NL( const int i )       { return this->at(i).NL(); }

  void Store( istream& is );
  void Read ( const char* file_name );
  void Write( ostream& os = cout, const int MAT = 0, const int MF = 0, const int MT = 0, int* NS = NULL ) const;
  void Write( const char* file_name ) const;

  unsigned long NumberOfLines() const;

  LTT1* Set( const LTT1& o );
  LTT1* Set( const char* file_name );
  LTT1* Set( const int n, const int interpcode = 2 );

  LTT1* Clear();

  LTT1* PushFront( const Record& o, const int interpcode = 2 );
  LTT1* PushBack ( const Record& o, const int interpcode = 2 );
  LTT1* PushFront( const LTT1&   o, const int interpcode = 2 );
  LTT1* PushBack ( const LTT1&   o, const int interpcode = 2 );

  LTT1* PutClone( const double elab );

  LTT1* PopFront( const int num = 1 );
  LTT1* PopBack ( const int num = 1 );

  LTT1* Erase( const double E );

  LTT1* CutBelow( const double elab, const double eps = 1.e-3 );
  LTT1* CutAbove( const double elab, const double eps = 1.e-3 );

  LTT1* Replace( const LTT1& o );

  bool Find( const double E ) const;
  bool Seek( const double E ) const;
  bool Seek( const double E, int* index, int* interpcode ) const;

  LTT1* ScaleEnergy( const double fac );

  double a( const double elab, const int l ) const;
  double a( const double elab_lower, const double elab_upper, const int l ) const;

  void   Interp( Record* result ) const;
  Record Interp( const double elab ) const;

  ////ClassDef( LTT1, 1 );

};

#endif

