#if !defined(___Class_TOF)
    #define  ___Class_TOF

#include <cmath>
#include <math.h>
////#include <TObject.h>

/*
- Units - length (m), time (ns)
*/

class TOF {

  double m, l, dt, dl;

 public:

  TOF();
  TOF( const double length, const double dlength, const double dtime );

  virtual ~TOF();

  TOF* Set( const double length, const double dlength, const double dtime );

  TOF* Mass  ( const double value ) { m = value; return this; }
  TOF* Length( const double value, const double delta = 0.0 ) { l = value; dl = delta; return this; }
  TOF* dTime ( const double fwhm = 0.0 ) { dt = fwhm; return this; }

  double t         ( const double e ) const;  // time of flight
  double Resolution( const double e ) const;  // energy resolution

  //double sigma( const double e ) const;
  //double FWHM ( const double e ) const;

  bool is_ready() const;

    //ClassDef( TOF, 1 );

};

#endif
