#ifndef _Approx_
#define _Approx_

#include <cstdlib>
#include <cmath>
#include <complex>
#include <algorithm>

////#include <TObject.h>
//#define pm(l) ( (l)%2 == 0 ? 1 : -1 )

using namespace std;

namespace Numeric {
/*
bool eq( const double a, const double b, const double eps =1.e-10 );
bool ne( const double a, const double b );
bool lt( const double a, const double b );
bool gt( const double a, const double b );
bool le( const double a, const double b );
bool ge( const double a, const double b );
*/


inline bool eq( const double& a, const double& b, const double eps = 1.e-15, const double zero = 1.e-38 ) {

  if( fabs(a-b) < zero ) return true;

  return ( fabs(a-b)/max(fabs(a),fabs(b)) < eps );

}

inline bool ne( const double& a, const double& b, const double eps = 1.e-15, const double zero = 1.e-38 ) {

  return !eq(a,b,eps,zero);

}

inline bool lt( const double& a, const double& b ) { return a<b && !eq(a,b); }
inline bool gt( const double& a, const double& b ) { return a>b && !eq(a,b); }

inline bool le( const double& a, const double& b ) { return eq(a,b) || lt(a,b); }
inline bool ge( const double& a, const double& b ) { return eq(a,b) || gt(a,b); }

inline bool eq( const complex<double>& a, const complex<double>& b, const double eps = 1.e-15, const double zero = 1.e-38 ) {

  return eq( real(a), real(b), zero, eps ) && eq( imag(a), imag(b), eps,zero );

}

};

#endif
