#include "ReconResonance/RmatrixLimited/numeric/Datum.h"
#include "ReconResonance/RmatrixLimited/numeric/Approx.h"

//ClassImp( Numeric::Datum );

namespace Numeric {


  Datum:: Datum() : v(0.,0.) {}
  Datum:: Datum( const double x, const double y ) : v(x,y) {}
  Datum::~Datum() {}


  void Datum::Write( ostream& os ) const {

    os.setf( ios::scientific );

    os << this->X() << this->Y() << endl;

    os.unsetf( ios::scientific );

    return;

  }



  bool Datum::operator==( const Datum& o ) const {

    //return ( this->X() == o.X() && this->Y() == o.Y() );

    return ( eq( this->X(), o.X() ) && eq( this->Y(), o.Y() ) );

  }

  bool Datum::operator!=( const Datum& o ) const {

    return !( *this == o );

  }

  bool Datum::operator<( const Datum& o ) const {

    if( lt( this->X(), o.X() ) ) return true ;
    if( gt( this->X(), o.X() ) ) return false;
    if( lt( this->Y(), o.Y() ) ) return true ;
    if( gt( this->Y(), o.Y() ) ) return false;

    return false;

  }

  bool Datum::operator>( const Datum& o ) const {

    return( ! this->operator<=( o ) );

  }

  bool Datum::operator<=( const Datum& o ) const {

    return ( this->operator==( o ) || this->operator<( o ) );

  }

  bool Datum::operator>=( const Datum& o ) const {

    return ( this->operator==( o ) || this->operator>( o ) );

  }



  // out stream

  ostream& operator<<( ostream& os, const Datum& o ) {

    o.Write( os );

    /*
    os.setf( ios::scientific );

    os << o.X() << "  " << o.Y();

    os.unsetf( ios::scientific );
    */
  
    //os << endf( o.X() ) << endf( o.Y() );

    return os;

  }


}
